# Examples

## Caddy as HTTPS server

The [servers.yml](servers.caddy-https.yml):

- we create only the zone "external"
- we create a module "caddy"
- we define an host "host.example.net":

  - servers are containerized with [machined](https://freedesktop.org/wiki/Software/systemd/machined/), so service application is "host-systemd-machined"
  - the provide application service is "provider-systemd-machined"

- we define a server "caddy"

## Caddy behind a Nginx reverse proxy

The [servers.yml](servers.caddy-https-rp.yml):

  - we create the zone "external" and a zone "revprox" between "revprox" and "caddy" servers
  - we create three module:

     - "revprox": the reverse proxy (with "letsencrypt" application service if needed)
     - "nsd": to manage local DNS name
     - "caddy"

  - we define an host "host.example.net":

    - servers are containerized with [machined](https://freedesktop.org/wiki/Software/systemd/machined/), so service application is "host-systemd-machined"
    - the provide application service is "provider-systemd-machined"

  - we define servers:

    - revprox in zones "external" and "revprox"
    - nsd in zone "revprox"
    - caddy in zone "revprox"

You must add a index.html file in "/var/lib/risotto/srv/caddy.in.example.net/caddy/".
